package com.ccnode.codegenerator.dom.model;

package .tmp;

import com.ccnode.codegenerator.dom.model.Delete;
import com.ccnode.codegenerator.dom.model.IdDomElement;
import com.ccnode.codegenerator.dom.model.Insert;
import com.ccnode.codegenerator.dom.model.ParameterMap;
import com.ccnode.codegenerator.dom.model.ResultMap;
import com.ccnode.codegenerator.dom.model.Select;
import com.ccnode.codegenerator.dom.model.Sql;
import com.ccnode.codegenerator.dom.model.Update;
import com.intellij.psi.PsiClass;
import com.intellij.util.xml.Attribute;
import com.intellij.util.xml.Convert;
import com.intellij.util.xml.DomElement;
import com.intellij.util.xml.GenericAttributeValue;
import com.intellij.util.xml.NameValue;
import com.intellij.util.xml.PsiClassConverter;
import com.intellij.util.xml.Required;
import com.intellij.util.xml.SubTagList;
import com.intellij.util.xml.SubTagsList;
import java.util.List;
import org.jetbrains.annotations.NotNull;

public interface Mapper extends DomElement {
  @SubTagsList({"insert", "update", "delete", "select"})
  @NotNull
  List<IdDomElement> getDaoElements();
  
  @Required
  @NameValue
  @Attribute("namespace")
  @Convert(PsiClassConverter.class)
  @NotNull
  GenericAttributeValue<PsiClass> getNamespace();
  
  @SubTagList("resultMap")
  @NotNull
  List<ResultMap> getResultMaps();
  
  @SubTagList("parameterMap")
  @NotNull
  List<ParameterMap> getParameterMaps();
  
  @SubTagList("sql")
  @NotNull
  List<Sql> getSqls();
  
  @SubTagList("insert")
  @NotNull
  List<Insert> getInserts();
  
  @SubTagList("update")
  @NotNull
  List<Update> getUpdates();
  
  @SubTagList("delete")
  @NotNull
  List<Delete> getDeletes();
  
  @SubTagList("select")
  @NotNull
  List<Select> getSelects();
  
  @SubTagList("select")
  Select addSelect();
  
  @SubTagList("update")
  Update addUpdate();
  
  @SubTagList("insert")
  Insert addInsert();
  
  @SubTagList("delete")
  Delete addDelete();
}
